<ui:composition
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            #{automatonManager.init()}
            <s:div id="globalDiv">
                <h1>#{messages['gazelle.pam.PAMTestAutomation']}</h1>
                <h:outputText
                        value="#{messages['gazelle.pam.ThisToolIsUsedToTestYourSUTForThePatientGenerati']}"/>
                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">

                    <ui:define name="panel_title">#{messages['gazelle.pam.Summary']}</ui:define>

                    <ui:include src="automatonBP6option.xhtml">
                        <ui:param name="isDisplayed"
                                  value="#{iti30Manager.isBp6Authorized()}"/>
                        <ui:param name="idsToRender" value="mainPatientPanel"/>
                    </ui:include>

                    <div class="row">
                        <h:panelGroup
                                rendered="#{!automatonManager.displayTestResults}">
                            <div class="col-lg-3">
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">#{messages['gazelle.pam.Workflow']}</ui:define>
                                    <div class="form-horizontal">
                                        <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                            <ui:param name="id" value="graphNameId"/>
                                            <ui:define name="label">#{messages['gazelle.simu.Name']}</ui:define>
                                            <h:selectOneMenu id="graphNameId"
                                                             value="#{automatonManager.selectedGraphExecution.graph}"
                                                             styleClass="form-control gzl-select-text">
                                                <s:selectItems value="#{automatonManager.getGraphDescriptionList()}"
                                                               var="currentGraph"
                                                               label="#{currentGraph.name}"
                                                               noSelectionLabel="#{messages['gazelle.simulator.PleaseSelect']}"/>
                                                <a4j:ajax event="change" render="globalDiv"
                                                />
                                            </h:selectOneMenu>
                                        </s:decorate>
                                        <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                                            <ui:define name="label">
                                                #{messages['net.ihe.gazelle.simulators.FullMovementsCoverage']}
                                            </ui:define>
                                            <h:selectBooleanCheckbox
                                                    value="#{automatonManager.selectedGraphExecution.fullEdgeCoverage}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                                            <ui:define name="label">
                                                #{messages['net.ihe.gazelle.patientmanager.ValidateTransactionInstances']}
                                            </ui:define>
                                            <h:selectBooleanCheckbox
                                                    value="#{automatonManager.selectedGraphExecution.validateTransactionInstance}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                                            <ui:define name="label">
                                                #{messages['net.ihe.gazelle.patientmanager.StartWithAnA28']}
                                            </ui:define>
                                            <h:selectBooleanCheckbox
                                                    value="#{automatonManager.startsWithA28}"/>
                                        </s:decorate>
                                    </div>
                                </ui:decorate>
                            </div>
                        </h:panelGroup>
                        <h:panelGroup rendered="#{automatonManager.selectedGraphExecution.graph != null}">
                            <div class="col-lg-9">
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">#{messages['gazelle.pam.SelectedGraph']}
                                        <a4j:commandLink id="fullScreenIcon" styleClass="pull-right"
                                                         onclick="jq162('#graphImage').modal('show');">
                                            <span class="fa fa-expand"></span>
                                        </a4j:commandLink>
                                    </ui:define>
                                    <div class="row">
                                        <div class="col-lg-8">
                                            <dl class="dl-horizontal">
                                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                    <ui:define name="label">
                                                        #{messages['net.ihe.gazelle.simulators.Id']}
                                                    </ui:define>
                                                    <h:outputText
                                                            value="#{automatonManager.selectedGraphExecution.graph.id}"/>
                                                    <h:commandLink id="downloadButton"
                                                                   actionListener="#{automatonManager.selectedGraphExecution.graph.downloadSelectedGraph()}">
                                                        <span class="gzl-icon-download"></span>
                                                    </h:commandLink>
                                                </s:decorate>
                                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                    <ui:define name="label">#{messages['gazelle.simu.Name']}</ui:define>
                                                    <h:outputText
                                                            value="#{automatonManager.selectedGraphExecution.graph.name}"/>
                                                </s:decorate>
                                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                    <ui:define name="label">
                                                        #{messages['net.ihe.gazelle.simulators.Description']}
                                                    </ui:define>
                                                    <h:outputText
                                                            value="#{automatonManager.selectedGraphExecution.graph.description}"/>
                                                </s:decorate>
                                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                    <ui:define name="label">
                                                        #{messages['net.ihe.gazelle.simulators.Movements']}
                                                    </ui:define>
                                                    <h:outputText
                                                            value="#{automatonManager.selectedGraphExecution.graph.edges}"/>
                                                </s:decorate>
                                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                    <ui:define name="label">
                                                        #{messages['net.ihe.gazelle.simulators.PatientStatuses']}
                                                    </ui:define>
                                                    <h:outputText
                                                            value="#{automatonManager.selectedGraphExecution.graph.vertices}"/>
                                                </s:decorate>
                                                <h:panelGroup
                                                        rendered="#{automatonManager.displayTestResults}">
                                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                                        <ui:define name="label">
                                                            #{messages['net.ihe.gazelle.simulators.FullMovementsCoverage']}
                                                        </ui:define>
                                                        <h:outputText
                                                                value="#{automatonManager.selectedGraphExecution.fullEdgeCoverage}"/>
                                                    </s:decorate>
                                                </h:panelGroup>
                                            </dl>
                                        </div>
                                        <div class="col-lg-4">
                                            <ui:decorate template="/layout/popup/_popup.xhtml">
                                                <ui:param name="styleClass" value="bigPopUp"/>
                                                <ui:param name="popup_id" value="graphImage"/>
                                                <img width="100%"
                                                     src="data:image/png;base64,#{automatonManager.selectedGraphExecution.graph.displaySelectedImage()}"/>
                                            </ui:decorate>
                                            <img width="100%"
                                                 src="data:image/png;base64,#{automatonManager.selectedGraphExecution.graph.displaySelectedImage()}"/>
                                        </div>
                                    </div>
                                </ui:decorate>
                            </div>
                        </h:panelGroup>
                    </div>

                    <h:panelGroup rendered="#{automatonManager.selectedGraphExecution.graph != null}">
                        <s:decorate template="/automaton/initiatorFrame.xhtml">
                            <ui:param name="actorKeyword"
                                      value="#{automatonManager.receivingActor.keyword}"/>
                            <ui:param name="diagramImg"
                                      value="diag/PES_GEN.png"/>
                            <ui:param name="currentConfig" value="#{automatonManager.selectedGraphExecution.sut}"/>
                            <ui:param name="simuFacility" value="#{automatonManager.sendingFacility}"/>
                            <ui:param name="simuApplication"
                                      value="#{automatonManager.sendingApplication}"/>
                            <ui:param name="sectionsToReRender" value="mainPatientPanel"/>
                            <ui:param name="simulatorConfigurationName"
                                      value="#{automatonManager.simulatedActor.name} #{messages['gazelle.PAMSimulator.Simulator']}"/>
                            <ui:param name="availableSuts" value="#{automatonManager.availableSystems}"/>
                            <ui:param name="renderSelectSystem" value="#{!automatonManager.displayTestResults}"/>
                            <ui:define name="moreDetails">
                                <ui:include src="/cat/assigningAuthoritiesForSystem.xhtml">
                                    <ui:param name="selectedSUT" value="#{automatonManager.selectedGraphExecution.sut}"/>
                                </ui:include>
                            </ui:define>
                        </s:decorate>
                    </h:panelGroup>

                    <s:div id="mainPatientPanel">
                        <h:panelGroup rendered="#{automatonManager.selectedGraphExecution.sut != null}">
                            <s:decorate template="patient.xhtml">
                            </s:decorate>
                        </h:panelGroup>
                    </s:div>


                    <h:panelGroup id="testReportsDiv" rendered="#{automatonManager.displayTestResults}">

                        <ui:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">#{messages['gazelle.pam.TestsReports']}</ui:define>
                            <a4j:poll id="poll" interval="1000"
                                      action="#{automatonManager.displayPermanentLinkMessage()}"
                                      enabled="#{automatonManager.graphExecutionResults.executionStatus == 'EXECUTING'}"
                                      render="testReportsDiv testResultsButtons"/>
                            <h:panelGroup
                                    rendered="#{automatonManager.graphExecutionResults.executionStatus != 'FAILED'}">
                                <ui:include src="automaton_message_table.xhtml">
                                    <ui:param name="messagesAutomaton"
                                              value="#{automatonManager.graphExecutionResults.messagesList}"/>
                                </ui:include>
                            </h:panelGroup>
                            <h:panelGroup
                                    rendered="#{automatonManager.graphExecutionResults.executionStatus == 'FAILED'}">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.simulators.ImpossibleToEstablishAConnectionWithTheSUTIP']} #{automatonManager.graphExecutionResults.graphExecution.sut.ipAddress}"
                                        styleClass="gzl-label gzl-label-red"/>
                            </h:panelGroup>
                        </ui:decorate>
                    </h:panelGroup>

                    <ui:define name="panel_footer">

                        <h:panelGroup
                                rendered="#{!automatonManager.displayTestResults}">
                            <a4j:commandButton value="#{messages['gazelle.pam.RunAutomaton']}"
                                               styleClass="gzl-btn-blue"
                                               render="globalDiv"
                                               action="#{automatonManager.run()}"/>
                        </h:panelGroup>
                        <h:panelGroup id="testResultsButtons" rendered="#{automatonManager.displayTestResults}">
                            <a4j:commandButton id="permalinkButton"
                                               styleClass="gzl-btn"
                                               action="#{automatonManager.displayCurrentPage(automatonManager.graphExecutionResults.getId().toString())}"
                                               rendered="#{automatonManager.isProcessEnded()}"
                                               value="#{messages['gazelle.pam.Permalink']}"/>
                            <a4j:commandButton id="playButton"
                                               render="globalDiv"
                                               styleClass="gzl-btn gzl-btn-blue"
                                               action="#{automatonManager.validate()}"
                                               rendered="#{automatonManager.graphExecutionResults.executionStatus == 'COMPLETED'}"
                                               value="#{messages['net.ihe.gazelle.patientmanager.RunValidation']}"/>
                            <a4j:commandButton id="replayButton"
                                               render="globalDiv"
                                               styleClass="gzl-btn gzl-btn-blue"
                                               action="#{automatonManager.replay()}"
                                               rendered="#{automatonManager.graphExecutionResults.executionStatus == 'VALIDATED'}"
                                               value="#{messages['gazelle.pam.Replay']}"/>
                            <a4j:commandButton id="backButton"
                                               styleClass="gzl-btn"
                                               action="#{automatonListManager.displayCurrentPage(null)}"
                                               value="#{messages['gazelle.pam.Back']}"/>
                        </h:panelGroup>
                    </ui:define>
                </ui:decorate>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>